// use std::convert::Infallible;
// use std::collections::HashMap;
use warp::{
  // http::{StatusCode},
  http::{method::Method, HeaderMap, HeaderValue},
  Reply, Rejection,
};
use reqenv::ReqEnv;
use app_env::profile::Profile;
/*
use crate::topographic_anatomy::defs::{TaStore,TaData,TaQueryFilters,TopographicAnatomy};
use zterton::kloud::utils::{lng_t,get_lang_items_str,load_lang};
//use zterton::models::{AppStore, AppData};

use crate::defs::AppDB;
use crate::auth::defs::{
  AuthError,
  Sessions,
  UserCtx,
  UserMap, 
  WebResult,
  SharedEnforcer,
  BEARER_PREFIX,
  custom_reject
};
*/
// use ::topographic_anatomy::{TopographicAnatomy};
// use ::tracking_point::{TrackingPoint};
// use crate::tracking_point::defs::{TrackingPoint};
//use app_auth::{UserCtx};
use kloud::{
  defs::{
		KloudQueryDefsFilters,
		KloudQueryLangFilters,
	},
  lang::LangItems,
};

use crate::defs::{DataDBs}; // ,CollsData};

// warp::generic::Either<(std::string::String,), (std::string::String,)>
pub async fn langs(
	opts: KloudQueryLangFilters,
	header: HeaderMap<HeaderValue>,
	method: Method,
//  user: UserCtx, 
	db: DataDBs, 
	prfx: String,
// headers: warp::http::HeaderMap
//  path: warp::path::FullPath, headers: warp::http::HeaderMap
) -> Result<impl Reply, Rejection> {
	let reqenv = ReqEnv::new(db.app, db.auth, header, method, "/langs", "langs", &prfx);
//  println!("User: {} | {}",&user.user_id,&user.token);
	// if let Some(lang) = reqtasks.params().get("lang") {
	//   res.render_json_text(&get_lang_items_str("langs",req_lang,"yaml"))
	// } else {
	//   res.render_json_text(&get_lang_items_str("langs",&reqtasks.lang(),"yaml"))
	// }
	// log::debug!("LANG: {} - {}",language, lang);
//  dbg!("LANG: {} - {}",language, lang);
	// let allow_origin = reqenv.websrvr().allow_origin;

	match reqenv.user_authentication().await {
		Ok(_auth) => {
			// dbg!("auth: {}",&auth); 
			let lang = opts.lang.unwrap_or_else(|| String::from("es"));
			let section = opts.section.unwrap_or_else(|| String::from(""));
			let lang_items = LangItems::new("langs/ta",&lang,"yaml");
			let result = lang_items.get_items_str(&section);
			Ok(warp::http::Response::builder()
			.body(result.to_string())
			.into_response())
			/*
			Ok(warp::reply::with_header(
				warp::http::Response::new(result),
					"Access-Control-Allow-Origin",
					&allow_origin))
			// Ok(warp::reply::json(&result))
			*/
		},
			Err(e) => {
			let result = format!("Error: no credentials found");
			println!("{}",e);
			Ok(warp::http::Response::builder()
			.body(result.to_string())
			.into_response())
			/*
			Ok(warp::reply::with_header(
				warp::http::Response::new(result),
				"Access-Control-Allow-Origin",
				&allow_origin))
			*/
			}
	}
}
// warp::generic::Either<(std::string::String,), (std::string::String,)>
pub async fn defs(
	_opts: KloudQueryDefsFilters,
	header: HeaderMap<HeaderValue>,
	method: Method,
//  user: UserCtx, 
	db: DataDBs, 
	prfx: String,
// headers: warp::http::HeaderMap
//  path: warp::path::FullPath, headers: warp::http::HeaderMap
) -> Result<impl Reply, Rejection> {
	let reqenv = ReqEnv::new(db.app, db.auth, header, method, "/defs", "defs", &prfx);
	// let allow_origin = reqenv.websrvr().allow_origin;
	match reqenv.user_authentication().await {
		Ok(auth) => {
			// dbg!("auth: {}",&auth); 
			// println!("User: {} | {}",&user.user_id,&user.token);
			// if let Some(lang) = reqtasks.params().get("lang") {
			//   res.render_json_text(&get_lang_items_str("langs",req_lang,"yaml"))
			// } else {
			//   res.render_json_text(&get_lang_items_str("langs",&reqtasks.lang(),"yaml"))
			// }
			// log::debug!("LANG: {} - {}",language, lang);
			//  dbg!("LANG: {} - {}",language, lang);

			let mut path = format!("{}/profiles/{}/{}/defs.yaml",reqenv.websrvr().resources_path,&prfx,&auth.user_id);
			if ! std::path::Path::new(&path).exists() {
				path = format!("{}/profiles/{}/defs.yaml",reqenv.websrvr().resources_path,&prfx);
			}
			let content = Profile::load_fs_content(path.into());
			// let lang = opts.lang.unwrap_or_else(|| String::from("es"));
			// let section = opts.section.unwrap_or_else(|| String::from(""));
			// let lang_items = LangItems::new("langs/ta",&lang,"yaml");
			// let result = lang_items.get_items_str(&section);
			let res = Profile::to_yaml(content); // String::from("");
			let result = serde_json::to_string(&res).unwrap_or_else(|_| String::from(""));
			Ok(warp::http::Response::builder()
			.body(result.to_string())
			.into_response())
			/*
			Ok(warp::reply::with_header(
					warp::http::Response::new(result),
						"Access-Control-Allow-Origin",
						&allow_origin))
			*/
			//  warp::reply::json(&res),
			// Ok(warp::reply::with_header(
			//  warp::http::Response::new(result),
			//    "Access-Control-Allow-Origin",
			//    &allow_origin))
			// Ok(warp::reply::json(&result))
		},
		Err(e) => {
			let result = format!("Error: no credentials found");
			println!("{}",e);
			Ok(warp::http::Response::builder()
			.body(result.to_string())
			.into_response())
			/*
			Ok(warp::reply::with_header(
			warp::http::Response::new(result),
			"Access-Control-Allow-Origin",
			&allow_origin))
			*/
		}
	}
}
