use async_graphql::{Context, Object, Result};

use crate::defs::DataDBs;
use crate::graphql::{Map,MutationType};

use klouds::Kloud;
use crate::filters::CollFilters;

pub fn load_klouds_filters() -> CollFilters {
  CollFilters {
    prfx: String::from("klouds"),
  }
}

#[derive(Clone,Default)]
pub struct KloudMainQuery;

#[Object]
impl KloudMainQuery {
    async fn klouds(&self, ctx: &Context<'_>) -> Vec<Kloud> {
      let data_dbs = ctx.data_unchecked::<DataDBs>();
      let cur = data_dbs.colls.klouds.entries.read();
      // let mut result: Vec<KloudMain> = Vec::new();
      // for (_,value) in cur.iter() {
      //   result.push(value.to_owned());
      // }
      cur.values().cloned().collect()
      // for (_,value) in cur.iter() {
      //   result.push(value.to_owned());
      // }

      //result
        // books.iter().map(|(_, book)| book).cloned().collect()
    }
}

#[derive(Clone,Default)]
pub struct KloudMainChanged {
  pub mutation_type: MutationType,
  pub id: String,
  pub objmap: Map,
}

#[Object]
impl KloudMainChanged {
    async fn mutation_type(&self) -> MutationType {
      self.mutation_type
    }
    async fn id(&self) -> &String {
      &self.id
    }
    async fn objmap(&self) -> &Map {
      &self.objmap
    }
    async fn klouds(&self, ctx: &Context<'_>) -> Result<Option<Kloud>> {
      let data_dbs = ctx.data_unchecked::<DataDBs>();
      // TODO Parse self.objmap 
      match self.mutation_type {
        MutationType::Created =>
          data_dbs.colls.klouds.entries.write()
          .insert(self.id.to_owned(), Kloud::default()),
        MutationType::Updated => 
          data_dbs.colls.klouds.entries.write()
           .insert(self.id.to_owned(), Kloud::default()),
        MutationType::Deleted => 
          data_dbs.colls.klouds.entries.write().remove(&self.id),
      };
      // let entry = data_dbs.data.ta.ta_entries.
      // let entry = d
      // let id = &self.id; // .parse::<usize>()?;
      // for (_,value) in cur.iter() {
      //   result.push(value.to_owned());
      // }
      // let books = ctx.data_unchecked::<Storage>().lock().await;
      // let id = self.id.parse::<usize>()?;
      // Ok(books.get(id).cloned())
      Ok(Some(Kloud::default()))
    }
}
/*
https://github.com/async-graphql/examples/blob/b36b5c44543b7323cb199ed229ea247e83b85d18/models/books/src/lib.rs

https://blog.logrocket.com/creating-a-rest-api-in-rust-with-warp/

  store.grocery_list.write().insert(item.name, item.quantity);
        Ok(warp::reply::with_status(
            "Added items to the grocery list",
            http::StatusCode::CREATED,
        ))
   store.grocery_list.write().remove(&id.name);
        Ok(warp::reply::with_status(
            "Removed item from grocery list",
            http::StatusCode::OK,
        ))
*/